/**
 * QueryEvalInfo class for interpret of RTL queries.
 */
#ifndef _QUERYEVALINFO_H
#define _QUERYEVALINFO_H

#include "query.h"
#include "queryvariableinfo.h"
#include "queryvargroup.h"
#include <vector>

using namespace std;

namespace vam
{
namespace rtl
{

class QueryEvalInfo
{
public:
    /**
     * @brief   Reference query to which the evaluation information is
     * provided.
     */
    PQuery query;

    /**
     * @brief   Prerequisites represent all the variables which changes of
     * their values should cause reseting this value. Each prerequisite should
     * be aware of evalinfo it belongs.
     */
    vector<PVariableInfo> prerequisites;

    /**
     * @brief   Variable group from which the value is evaluated.
     */
    VariableGroup vgroup;

    PQuery value;

    bool evaluating = false;


};

} // namespace rtl
} // namespace vam

#endif
