/**
 * Query interpret exceptions
 */
#ifndef _QUERYINTBASICTYPES_H
#define _QUERYINTBASICTYPES_H

#include "query.h"

using namespace std;

namespace vam
{
namespace rtl
{

class InterpretException : public VAMException
{
public:
    InterpretException(string m) noexcept : VAMException(m) {}
    const char* what() const noexcept { return "InterpretException"; }
};

inline void invalid_operand(string q, string expected)
{
    throw InterpretException("invalid operand in query '" + q + 
            "', expected " + expected);
}

class VariableException : public InterpretException
{
public:
    VariableException(string m) noexcept : InterpretException(m) {}
    const char* what() const noexcept { return "VariableException"; }
};

class VariableGroup;
class Interpret;
class VariableInfo;

using PVariableGroup = VariableGroup*;
using PVariableInfo = VariableInfo*;

template<typename T>
inline bool vector_contains(vector<T> &vec, const T &value)
{
    return std::find(vec.begin(), vec.end(), value) != vec.end();
}

} // namespace rtl
} // namespace vam

#endif
