/**
 * VariableGroup class for interpret of RTL queries.
 */
#include "queryvargroup.h"
#include <algorithm>

namespace vam
{
namespace rtl
{
/*
void VariableGroup::insert(PVariableInfo newv)
{
    // add a new variable to the list
    variables.push_back(newv);
    for (auto v : newv->bound_prerequisites)
    {
        variables.push_back(v);
        v->vgroups.insert(this);
    }
    newv->vgroups.insert(this);

    // sort wrt. bound dependencies
    std::sort(variables.begin(), variables.end(),
            [](PVariableInfo a, PVariableInfo b){

        // a < b iff b \in a->bound_prerequisites
        return (a->bound_prerequisites.count(b));
    });
}*/

void VariableGroup::insert(VarSet &vars)
{
    for (auto v : vars)
        variables.push_back(v);
    // sort wrt. bound dependencies
    std::sort(variables.begin(), variables.end(),
            [](PVariableInfo a, PVariableInfo b){

        // a < b iff b \in a->bound_prerequisites
        return (a->bound_prerequisites.count(b));
    });
}

bool VariableGroup::next_value_combination()
{
    bool commands = false;
    for (auto v : variables)
    {
        commands = v->evaluate_next(driver);
        if (commands)
        {
            if (v->novalue())
            {
                if (v == variables.back())
                    return false; // no more value combination
                else
                {
                    v->reset();
                    continue;
                }
            }
            else
                return true;
        }
        else
            continue;
    }
    return commands;
}

void VariableGroup::drive_undriven()
{
    for (auto v : variables)
        if (v->driver == nullptr)
            v->driver = driver;
}

} // namespace rtl
} // namespace vam
